--- a/lib/ohai/mixin/gce_metadata.rb/gce_metadata.rb
+++ b/lib/ohai/mixin/gce_metadata.rb/gce_metadata.rb
@@ -23,7 +23,7 @@

       # Trailing dot to host is added to avoid DNS search path
       GCE_METADATA_ADDR = "metadata.google.internal." unless defined?(GCE_METADATA_ADDR)
-      GCE_METADATA_URL = "/computeMetadata/v1/?recursive=true" unless defined?(GCE_METADATA_URL)
+      GCE_METADATA_URL = "/computeMetadata/v1" unless defined?(GCE_METADATA_URL)

       def can_metadata_connect?(addr, port, timeout = 2)
         t = Socket.new(Socket::Constants::AF_INET, Socket::Constants::SOCK_STREAM, 0)
@@ -65,7 +65,9 @@
       end

       def fetch_metadata(id = "")
-        response = http_get("#{GCE_METADATA_URL}/#{id}")
+        url = "#{GCE_METADATA_URL}/#{id}"
+        url << "?recursive=true" if url.end_with?("/")
+        response = http_get(url)
         return nil unless response.code == "200"

         if json?(response.body)
